﻿Arena = LibStub("AceAddon-3.0"):NewAddon("Arena", "AceEvent-3.0")
local scheduleframe = CreateFrame("Frame")
local lsm3 = LibStub("LibSharedMedia-3.0")
local auracache, drs, enemytalents, enemyspells, cdoverrides = {}, {}, {}, {}, {}
local cooldowns = {
	[42292] = 120,
	[642] = 300,
	[1044] = 25,
	[1953] = 15,
	[45438] = 230,
	[53271] = 60,
	[18499] = 30,
	[46924] = 90,
	[60970] = 45,
	[50334] = 180,
	[586] = 30,
	[47585] = 120,
	[1856] = 90,
	[31224] = 60,
	[11305] = 120,
	[48020] = 30,
	[7744] = 120,
	[20589] = 105,
}
local cooldownnames
local CCs = {
	["PALADIN"]={
		[853]="STUN",
		[20066]="INCAPACIPATE",
		[53709]="SILENCE",
	},
	["DRUID"]={
		[33786]="CYCLONE",
		[22570]="STUN",
		[9005]="OPENER_STUN",
		--[16979]="CHARGE",
		[5211]="STUN",
		[339]="ROOT",
	},
	["DEATHKNIGHT"]={
		[47476]="SILENCE",
		[49203]="DISORIENT",
		[47481]="STUN",
	},
	["HUNTER"]={
		[1499]="DISORIENT",
		[19503]="SCATTERSHOT",
		[19577]="STUN",
		[19386]="DISORIENT",
	},
	["WARRIOR"]={
		[100]="CHARGE",
		[5246]="FEAR",
		[12809]="STUN",
		[46968]="STUN",
	},
	["MAGE"]={
		[28271]="POLYMORPH",
		[12598]="SILENCE",
		[44572]="STUN",
	},
	["PRIEST"]={
		[8122]="FEAR",
		[15487]="SILENCE",
	},
	["WARLOCK"]={
		[5782]="FEAR",
		[6358]="CHARM",
		[30283]="STUN",
		[19647]="SILENCE",
	},
	["SHAMAN"]={
		[51514]="POLYMORPH",
	},
	["ROGUE"]={
		[26884]="SILENCE",
		[1833]="OPENER_STUN",
		[8643]="STUN",
		[51724]="SAP",
		[2094]="BLIND",
	},
	["Tauren"]={
		[20549]="STUN",
	},
	["BloodElf"]={
		[28730]="SILENCE",
	},
}

local talents = {
	["PALADIN"]={
		[31821]={tree=1, points=11},
		[20216]={tree=1, points=21},
		[48825]={tree=1, points=31},
		[31842]={tree=1, points=41},
		[53563]={tree=1, points=51},
		[64205]={tree=2, points=11},
		[20911]={tree=2, points=21},
		[48952]={tree=2, points=31},
		[48827]={tree=2, points=41},
		[53595]={tree=2, points=51},
		[20375]={tree=3, points=11},
		[20066]={tree=3, points=31},
		[35395]={tree=3, points=41},
		[53385]={tree=3, points=51},
	},
	["MAGE"]={
		[54646]={tree=1, points=11},
		[12043]={tree=1, points=21},
		[12042]={tree=1, points=31},
		[31589]={tree=1, points=41},
		[44781]={tree=1, points=51},
		[42891]={tree=2, points=11},
		[42945]={tree=2, points=21},
		[11129]={tree=2, points=31},
		[42950]={tree=2, points=41},
		[55360]={tree=2, points=51},
		[12472]={tree=3, points=11},
		[11958]={tree=3, points=21},
		[43039]={tree=3, points=31},
		[31687]={tree=3, points=41},
		[44572]={tree=3, points=51},
	},
	["HUNTER"]={
		[19577]={tree=1, points=21},
		[19574]={tree=1, points=31},
		[49050]={tree=2, points=11},
		[23989]={tree=2, points=21},
		[19506]={tree=2, points=31},
		[34490]={tree=2, points=41},
		[53209]={tree=2, points=51},
		[19503]={tree=3, points=11},
		[48999]={tree=3, points=21},
		[49012]={tree=3, points=31},
		[63672]={tree=3, points=41},
		[60053]={tree=3, points=51},
	},
	["SHAMAN"]={
		[16166]={tree=1, points=31},
		[57722]={tree=1, points=41},
		[59159]={tree=1, points=51},
		[17364]={tree=2, points=31},
		[60103]={tree=2, points=36},
		[30823]={tree=2, points=41},
		[51533]={tree=2, points=51},
		[55198]={tree=3, points=11},
		[16188]={tree=3, points=21},
		[51886]={tree=3, points=31},
		[16190]={tree=3, points=31},
		[49284]={tree=3, points=41},
		[61301]={tree=3, points=51},
	},
	["WARRIOR"]={
		[12328]={tree=1, points=21},
		[47486]={tree=1, points=31},
		[46924]={tree=1, points=51},
		[12323]={tree=2, points=11},
		[12292]={tree=2, points=21},
		[23881]={tree=2, points=31},
		[29801]={tree=2, points=41},
		[12975]={tree=3, points=11},
		[12809]={tree=3, points=21},
		[50720]={tree=3, points=31},
		[47498]={tree=3, points=41},
		[46968]={tree=3, points=51},
	},
	["DRUID"]={
		[48468]={tree=1, points=21},
		[24858]={tree=1, points=31},
		[33831]={tree=1, points=41},
		[61384]={tree=1, points=41},
		[53201]={tree=1, points=51},
		[61336]={tree=2, points=11},
		[16979]={tree=2, points=21},
		[49376]={tree=2, points=21},
		[33917]={tree=2, points=41},
		[50334]={tree=2, points=51},
		[17116]={tree=3, points=21},
		[18562]={tree=3, points=31},
		[65139]={tree=3, points=41},
		[53251]={tree=3, points=51},
	},
	["DEATHKNIGHT"]={
		[48982]={tree=1, points=11},
		[49005]={tree=1, points=21},
		[49016]={tree=1, points=31},
		[55262]={tree=1, points=41},
		[49028]={tree=1, points=51},
		[49039]={tree=2, points=11},
		[49796]={tree=2, points=21},
		[49203]={tree=2, points=31},
		[55268]={tree=2, points=41},
		[51411]={tree=2, points=51},
		[51328]={tree=3, points=11},
		[49194]={tree=3, points=21},
		[51052]={tree=3, points=31},
		[49222]={tree=3, points=36},
		[55271]={tree=3, points=41},
		[49206]={tree=3, points=51},
	},
	["PRIEST"]={
		[14751]={tree=1, points=11},
		[10060]={tree=1, points=31},
		[33206]={tree=1, points=41},
		[53007]={tree=1, points=51},
		[48173]={tree=2, points=11},
		[20711]={tree=2, points=21},
		[48087]={tree=2, points=31},
		[48089]={tree=2, points=41},
		[47788]={tree=2, points=51},
		[48156]={tree=3, points=11},
		[15286]={tree=3, points=21},
		[15487]={tree=3, points=21},
		[15473]={tree=3, points=31},
		[48160]={tree=3, points=41},
		[47585]={tree=3, points=51},
	},
	["ROGUE"]={
		[14177]={tree=1, points=21},
		[58426]={tree=1, points=31},
		[48666]={tree=1, points=41},
		[51662]={tree=1, points=51},
		[14251]={tree=2, points=11},
		[13877]={tree=2, points=21},
		[13750]={tree=2, points=31},
		[51690]={tree=2, points=51},
		[14278]={tree=3, points=11},
		[28660]={tree=3, points=21},
		[14185]={tree=3, points=21},
		[14183]={tree=3, points=31},
		[36554]={tree=3, points=41},
		[51713]={tree=3, points=51},
	},
	["WARLOCK"]={
		[18223]={tree=1, points=21},
		[59092]={tree=1, points=31},
		[47843]={tree=1, points=41},
		[59164]={tree=1, points=51},
		[19028]={tree=2, points=11},
		[18708]={tree=2, points=11},
		[47193]={tree=2, points=31},
		[30146]={tree=2, points=41},
		[59672]={tree=2, points=51},
		[47827]={tree=3, points=11},
		[17962]={tree=3, points=31},
		[47847]={tree=3, points=41},
		[59172]={tree=3, points=51},
	},
}
local cc_breakers = {
	["ALL"]={
		[42292] = {["ALL"]=true}
	},
	["PALADIN"]={
		[642] = {["ALL"]=true},
		[1044] = {["ROOT"]=true, ["STUN"]={3,26}},
	},
	["MAGE"]={
		[1953] = {["STUN"]=true, ["OPENER_STUN"]=true, ["CHARGE"]=true, ["ROOT"]=true},
		[45438] = {["ALL"]=true},
	},
	["HUNTER"]={
		[53271] = {["ROOT"]=true},
		[19574] = {["ALL"]={1,41}},
	},
	["SHAMAN"] = {
	},
	["WARRIOR"] = {
		[18499] = {["SAP"]=true, ["INCAPACIPATE"]=true, ["FEAR"]=true},
		[46924] = {["ROOT"]={1,51}},
		[60970] = {["ROOT"]={2,41}},
	},
	["DRUID"] = {
		[0] = {["ROOT"]=true, ["POLYMORPH"]=true},
		[50334] = {["FEAR"]={2,51}},
	},
	["DEATHKNIGHT"] = {
	},
	["PRIEST"] = {
		[586] = {["ROOT"]={3,36}},
		[47585] = {["ROOT"]={3,51}},
	},
	["ROGUE"] = {
		[1856] = {["ROOT"]=true},
		[31224] = {["ROOT"]=true},
		[11305] = {["ROOT"]={2,16}},
	},
	["WARLOCK"] = {
		[48020] = {["ROOT"]=true},
	},
	["Scourge"] = {
		[7744] = {["FEAR"]=true, ["CHARM"]=true, ["SLEEP"]=true},
	},
	["Gnome"] = {
		[20589] = {["ROOT"]=true}
	},
}

local shared_cds = {
	[7744] = {[42292]=45},
	[42292] = {[7744]=45,[59752]=120},
	[59752] = {[42292]=120},
}

local dr_categories = {
	[853]="STUN",
	[20066]="INCAPACIPATE",
	[53709]="SILENCE",
	[33786]="CYCLONE",
	[22570]="STUN",
	[9005]="OPENER_STUN",
	--[16979]="CHARGE",
	[5211]="STUN",
	[339]="ROOT",
	[47476]="SILENCE",
	[49203]="DISORIENT",
	[47481]="STUN",
	[1499]="DISORIENT",
	[19503]="SCATTERSHOT",
	[19577]="STUN",
	[19386]="SLEEP",
	[100]="CHARGE",
	[5246]="FEAR",
	[12809]="STUN",
	[46968]="STUN",
	[28271]="POLYMORPH",
	[12598]="SILENCE",
	[8122]="FEAR",
	[15487]="SILENCE",
	[5782]="FEAR",
	[6358]="CHARM",
	[30283]="STUN",
	[19647]="SILENCE",
	[51514]="POLYMORPH",
	[26884]="SILENCE",
	[1833]="OPENER_STUN",
	[8643]="STUN",
	[51724]="SAP",
	[2094]="BLIND",
	[20549]="STUN",
	[28730]="SILENCE",
	[44572]="STUN",
}
local reverse_cats = setmetatable({}, {__index=function(t,v) local a = {} for i,k in pairs(dr_categories) do if v == k then tinsert(a, i) end end t[v]=a return a end})
local talent_spells = {
	[12598]={1,12},
	[53709]={2,24},
}
local shared_drs={
	["FEAR"]={"CHARM","BLIND"},
	["CHARM"]={"FEAR","BLIND"},
	["BLIND"]={"FEAR","CHARM"},
	["DISORIENT"]={"SAP","POLYMORPH","SLEEP"},
	["SAP"]={"DISORIENT","POLYMORPH","SLEEP"},
	["POLYMORPH"]={"DISORIENT","SAP","SLEEP"},
	["SLEEP"]={"DISORIENT","SAP","POLYMORPH"},
}
local debuff_ids={
	[853]=853,
	[20066]=20066,
	[63529]=53709,
	[33786]=33786,
	[22570]=22570,
	[9005]=9005,
	--[45334]=16979,
	[5211]=5211,
	[339]=339,
	[47476]=47476,
	[49203]=49203,
	[47481]=47481,
	[14309]=1499,
	[1499]=1499,
	[19503]=19503,
	[19577]=19577,
	[19386]=19386,
	[7922]=100,
	[5246]=5246,
	[12809]=12809,
	[46968]=46968,
	[28271]=28271,
	[55021]=12598,
	[8122]=8122,
	[15487]=15487,
	[5782]=5782,
	[6358]=6358,
	[30283]=30283,
	[19647]=19647,
	[51514]=51514,
	[1330]=26884,
	[1833]=1833,
	[8643]=8643,
	[51724]=51724,
	[2094]=2094,
	[20549]=20549,
	[28730]=28730,
}

local reverse_debuffids = setmetatable({}, {__index=function(t,v) local a = {} for i,k in pairs(debuff_ids) do if k == v then tinsert(a, i) end end t[v] = a return a end})

scheduleframe.s = {}
scheduleframe:SetScript("OnUpdate", function(self)
	if #self.s < 1 then self:Hide() return end
	while self.s[1] and self.s[1].t <= GetTime() do
		if type(self.s[1].f) == "string" then
			Arena[self.s[1].f](Arena, unpack(self.s[1].a))
		else
			self.s[1].f(unpack(self.s[1].a))
		end
		tremove(self.s,1)
	end
end)
local function round(num, places)
	return tonumber(string.format("%."..(places or 0).."f",num))
end
local options = {
	type="group",
	args={}
}
local defaults={profile={
	looks = {
		font = lsm3:GetDefault("font"),
		bar = lsm3:GetDefault("statusbar"),
		gryphon = true,
	},
	positioning = {
		enemy={},
		friendly={},
	},
	attributes={
		enemy={
			type2="focus",
		},
		friendly={
			type2="assist",
		}
	}
}}
function Arena:ScheduleTimer(t, f, ...)
	t = t+GetTime()
	tinsert(scheduleframe.s, {t=t,f=f,a={...}})
	table.sort(scheduleframe.s, function(a,b) return a.t < b.t end)
	if not scheduleframe:IsShown() then scheduleframe:Show() end
end
function Arena:OnProfileEnable()
	self.opt = self.db.profile
end
local hframes = {}
function Arena:ScheduleHide(f)
	tinsert(hframes, f)
	f:SetScript("OnUpdate", nil)
end

local frameupdate = function(self)
	local u = self.unit
	local h,p,mh,mp,cr,cg,cb,pbct,uh,up,upt,ue,uc, uht
	ue = UnitExists(u)
	if ue then
		h,p,mh,mp,cr,cg,cb = UnitHealth(u), UnitPower(u), UnitHealthMax(u), UnitPowerMax(u)
		_, uc = UnitClass(u)
		pbct = PowerBarColor[(select(2,UnitPowerType(u)))]
		cr,cg,cb = pbct.r,pbct.g,pbct.b
		if self.c.h ~= h then
			self.c.h = h
			uh = true
		end
		if self.c.mh ~= mh then
			self.c.mh = mh
			uh = true
		end
		if self.c.p ~= p then
			self.c.p = p
			up = true
		end
		if self.c.mp ~= mp then
			self.c.mp = mp
			up = true
		end
		if self.c.cr ~= cr then
			self.c.cr = cr
			upt = true
		end
		if self.c.cg ~= cg then
			self.c.cg = cg
			upt = true
		end
		if self.c.cb ~= cb then
			self.c.cb = cb
			upt = true
		end
		if self.c.uc ~= uc then
			self.c.uc = uc
			uht = true
		end
		if uh then
			local hf = self.health
			hf.t:SetText(h.."/"..mh.." ("..(mh == 0 and 0 or round(h/mh*100,0)).."%)")
			hf.tx:SetWidth(h == 0 and -1 or hf:GetWidth()*h/mh)
		end
		if up then
			local pf = self.power
			pf.t:SetText(p.."/"..mp.." ("..(mp == 0 and 0 or round(p/mp*100,0)).."%)")
			pf.tx:SetWidth(p == 0 and -1 or pf:GetWidth()*p/mp)
		end
		if uht then
			local a = RAID_CLASS_COLORS[uc]
			self.health.tx:SetVertexColor(a.r,a.g,a.b)
			Arena:UpdateColoring(u)
		end
		if upt then
			self.power.tx:SetVertexColor(cr,cg,cb)
		end
	else
		self.c.h, self.c.mh, self.c.p, self.c.mp = -2,-2,-2,-2
		self.health.t:SetText("?/?")
		self.health.tx:SetWidth(-1)
		self.power.t:SetText("?/?")
		self.power.tx:SetWidth(-1)
	end
end
function Arena:PLAYER_REGEN_ENABLED()
	for i,k in ipairs(hframes) do
		k:Hide()
		k:SetScript("OnUpdate", frameupdate)
	end
	table.wipe(hframes)
end

local function framedown(self,button)
	if button == "RightButton" and (IsLeftShiftKeyDown() or IsRightShiftKeyDown()) and not InCombatLockdown() then
		self.moving = true
		self:StartMoving()
	end
end

function Arena:InitFrame(frame)
	local unit, key = frame.unit, frame.key
	if key:find("1") then
		frame:SetMovable(true)
		frame:SetScript("OnMouseDown", framedown)
	end
	frame.health = CreateFrame("Frame", nil, frame)
	frame.power = CreateFrame("Frame", nil, frame)
	--frame.health:SetPoint("TOPRIGHT", )
	frame.health.tx = frame.health:CreateTexture(nil, "BACKGROUND")
	frame.health.tx:SetPoint("TOPLEFT")
	frame.health.tx:SetPoint("BOTTOMLEFT")
	frame.health.tx:SetTexture(lsm3:Fetch("statusbar", self.opt.looks.bar))
	frame.health.t = frame.health:CreateFontString(nil, "ARTWORK")
	frame.health.t:SetAllPoints()
	frame.health.t:SetFont(lsm3:Fetch("font", self.opt.looks.font), 16, "OUTLINE")
	frame.health.t:SetTextColor(1,1,1)
	frame.power:SetPoint("TOPLEFT", frame.health, "BOTTOMLEFT")
	frame.power:SetPoint("TOPRIGHT", frame.health, "BOTTOMRIGHT")
	frame.power.tx = frame.power:CreateTexture(nil, "BACKGROUND")
	frame.power.tx:SetPoint("TOPLEFT")
	frame.power.tx:SetPoint("BOTTOMLEFT")
	frame.power.tx:SetTexture(lsm3:Fetch("statusbar", self.opt.looks.bar))
	frame.power.t = frame.power:CreateFontString(nil, "ARTWORK")
	frame.power.t:SetAllPoints()
	frame.power.t:SetFont(lsm3:Fetch("font", self.opt.looks.font), 16, "OUTLINE")
	frame.power.t:SetTextColor(1,1,1)
	frame.c = {}
	frame:SetScript("OnUpdate", frameupdate)
	frame.texture = frame:CreateTexture(nil, "BORDER")
	frame.texture:SetAllPoints()
	frame.tframe = CreateFrame("Frame", nil, frame)
	frame.tframe:SetFrameLevel(3)
	frame.texture2 = frame.tframe:CreateTexture(nil, "ARTWORK")
	frame.texture2:SetAllPoints(frame)
	if not self.opt.looks.gryphon then
		frame.texture2:Hide()
	end
	frame.toptext = frame:CreateFontString(nil, "OVERLAY")
	frame.toptext:SetFont(lsm3:Fetch("font", self.opt.looks.font), 10, "OUTLINE")
	frame.toptext:SetTextColor(1,1,1)
	frame:Hide()
end

function Arena:UpdateFrameShowHide()
	if InCombatLockdown() then return end
	local isArena = IsActiveBattlefieldArena()
	local teamsize
	if isArena then
		for bg=1, MAX_BATTLEFIELD_QUEUES do
			local status, mapname, instanceid, bracketmin, bracketmax, size = GetBattlefieldStatus(bg)
			if status == "active" and size ~= 0 then
				teamsize = size
				break
			end
		end
	else
		teamsize = 0
	end
	for nf=1, teamsize do
		self.frames["arena"..nf]:Show()
		self.frames["arena"..nf].toptext:SetText("0/0/0")
		self.frames["team"..nf]:Show()
		auracache["arena"..nf] = {}
		drs["arena"..nf] = {}
		enemytalents["arena"..nf]={[1]=0,[2]=0,[3]=0,remain=71}
		enemyspells["arena"..nf] = {}
		cdoverrides["arena"..nf] = {}
		self:UpdateDisplays("arena"..nf)
		self:UpdateColoring("arena"..nf)
	end
	for nhf=teamsize+1, 5 do
		self.frames["arena"..nhf]:Hide()
		self.frames["team"..nhf]:Hide()
	end
end

--[[function Arena:PLAYER_ENTERING_WORLD()
	Arena:ScheduleTimer(0.5, "UpdateFrameShowHide")
	self:UpdateFrameShowHide()
end--]]

function Arena:HasCCApplied(unit, category)
	if not UnitExists(unit) then return end
	local debuffs = reverse_cats[category]
	for n, id in pairs(debuffs) do
		local debuffnames = reverse_debuffids[id]
		for c, name in pairs(debuffnames) do
			if UnitDebuff(unit, name) then
				return true
			end
		end
	end
end

function Arena:IsImmuneToCC(unit, category)
	if not UnitExists(unit) then return end
end

function Arena:GetLowestPossibleCooldown(spellid)
	return cooldowns[spellid]
end

function Arena:IsOverrideCooldown(unit,spellid)
	return cdoverrides[unit][spellid]
end

function Arena:IsOnCooldown(unit, spellid)
	return ((enemyspells[unit][spellid] or 0) + (self:IsOverrideCooldown(unit, spellid) or self:GetLowestPossibleCooldown(spellid) or 0)) > GetTime()
end

function Arena:IsPossibleTalent(unit, tree, numpoints)
	return (enemytalents[unit][tree]+enemytalents[unit].remain) >= numpoints
end

function Arena:CanBreakCC(unit, category)
	if not UnitExists(unit) then return end
	local _,c = UnitClass(unit)
	local _,r = UnitRace(unit)
	local breaks = {}
	for id,x in pairs(cc_breakers.ALL) do
		local d = x[category] or breaks.ALL
		if d == true then
			if not Arena:IsOnCooldown(unit, id) then
				return true
			end
		end
	end
	for id,x in pairs(cc_breakers[c]) do
		local d = x[category] or breaks.ALL
		if d == true then
			if not Arena:IsOnCooldown(unit, id) then
				return true
			end
		elseif d then
			if Arena:IsPossibleTalent(unit, unpack(d)) then
				if not Arena:IsOnCooldown(unit,id) then
					return true
				end
			end
		end
	end
	if cc_breakers[r] then
		for id,x in pairs(cc_breakers[r]) do
			local d = x[category] or breaks.ALL
			if d == true then
				if not Arena:IsOnCooldown(unit, id) then
					return true
				end
			end
		end
	end
end

function Arena:UpdateColoring(unit)
	if not unit:find("arena%d") then return end
	local f = self.frames[unit]
	local i = 1
	local k = f["spell"..i]
	while k:IsShown() do
		do
			local id = k.id
			if self:HasCCApplied(unit, dr_categories[id]) then
				f["btn"..i.."in"]:SetVertexColor(0,0,1)
				break
			end
			if self:IsImmuneToCC(unit, dr_categories[id]) then
				f["btn"..i.."in"]:SetVertexColor(1,0,0)
				break
			end
			if self:CanBreakCC(unit, dr_categories[id]) then
				f["btn"..i.."in"]:SetVertexColor(1,0.6,0)
				break
			end
			f["btn"..i.."in"]:SetVertexColor(0,1,0)
			i=i+1
			k=f["spell"..i]
		end
	end
end

function Arena:UpdateEnemyTalentText(unit,spell)
	local talents = enemytalents[unit]
	print("Updated talents for unit "..unit.." to: "..talents[1].."/"..talents[2].."/"..talents[3]..". "..talents.remain.." remaining. (Reason: cast "..spell..")")
	self.frames[unit].toptext:SetText(talents[1].."/"..talents[2].."/"..talents[3])
end

function Arena:CombatEvent(event, ...)
	local e, sg = select(2, ...)
	if not (e=="SPELL_CAST_SUCCESS" or e=="SPELL_CAST_START") then return end
	local u
	for i=1, 5 do
		if UnitExists("arena"..i) and (UnitGUID("arena"..i) == sg) then
			u="arena"..i
			break
		end
	end
	if not u then return end
	local sid, sn = select(9, ...)
	local lc, c = UnitClass(u)
	local tcsn = talents[c][sn]
	if tcsn then
		if enemytalents[u][tcsn.tree] < tcsn.points then
			enemytalents[u][tcsn.tree] = tcsn.points
			enemytalents[u].remain = (71-(enemytalents[u][1]+enemytalents[u][2]+enemytalents[u][3]))
			self:UpdateColoring(u)
			self:UpdateEnemyTalentText(u,sn)
		end
	end
	local cdt = enemyspells[u]
	if cdt and cooldowns[cooldownnames[sn]] then
		cdt[cooldownnames[sn]] = GetTime()
		cdoverrides[u][cooldownnames[sn]] = nil
		if shared_cds[cooldownnames[sn]] then
			for n, cooldown in pairs(shared_cds[cooldownnames[sn]]) do
				cdoverrides[u][n] = cooldown
				cdt[n] = GetTime()
			end
		end
		self:UpdateColoring(u)
	end
end

function Arena:ScanSpellIDs()
	local a={}
	for n,i in pairs(debuff_ids) do
		if type(n) == "number" then
			a[(GetSpellInfo(n))] = i
		end
	end
	debuff_ids = a
	for class, classtable in pairs(talents) do
		local t = {}
		for spellid, spelldata in pairs(classtable) do
			if type(spellid) == "number" then
				local s = GetSpellInfo(spellid)
				if s then
					t[(GetSpellInfo(spellid))] = spelldata
				else
					print(s)
				end
			end
		end
		talents[class] = t
	end
	cooldownnames = {}
	for spellid in pairs(cooldowns) do
		cooldownnames[(GetSpellInfo(spellid))] = spellid
	end
	self:UnregisterEvent("SPELLS_CHANGED")
end
Arena:RegisterEvent("SPELLS_CHANGED","ScanSpellIDs")

function Arena:UpdateNameDisplay(event, unit)
	local u = string.match(unit, "party(%d)")
	if unit == "player" then u = 0 end
	if not u then return end
	u = tonumber(u) + 1
	f = self.frames["team"..u]
	f.name:SetText((UnitName(unit)))
end
Arena:RegisterEvent("UNIT_NAME_UPDATE", "UpdateNameDisplay")

function Arena:UpdateDisplays(unit)
	local aura, dr = auracache[unit], drs[unit]
	local applicable_debuffs = {}
	for num in pairs(CCs[(select(2, UnitClass("player")))]) do
		if talent_spells[num] then
			local _,_,_,_,rank = GetTalentInfo(unpack(talent_spells[num]))
			if rank > 0 then
				tinsert(applicable_debuffs, {t="talent", id=num, tab=talent_spells[num][1], talent=talent_spells[num][2]})
			end
		elseif (GetSpellInfo((GetSpellInfo(num)))) then
			tinsert(applicable_debuffs, {t="spell",id=num})
		end
	end
	if CCs[(select(2, UnitRace("player")))] then
		for num in pairs(CCs[(select(2, UnitRace("player")))]) do
			tinsert(applicable_debuffs, {t="spell",id=num})
		end
	end
	for i,k in ipairs(applicable_debuffs) do
		local n,r,ic
		if k.t=="spell" then
			n,r,ic= GetSpellInfo(k.id)
		elseif k.t == "talent" then
			n,ic = GetTalentInfo(k.tab,k.talent)
		end
		local f = self.frames[unit]
		f["spell"..i]:Show()
		f["spell"..i]:SetTexture(ic)
		f["btn"..i.."in"]:Show()
		local d = dr[dr_categories[k.id]] or 0
		f["btn"..i.."in"]:SetTexture("Interface\\AddOns\\Arena\\button_in"..(d==2 and "_quarter.tga" or d==1 and "_half.tga" or ".tga"))
		f["btn"..i]:Show()
		f["spell"..i].id = k.id
	end
	for c=(#applicable_debuffs+1), 5 do
		local f = self.frames[unit]
		f["btn"..c]:Hide()
		f["btn"..c.."in"]:Hide()
		f["spell"..c]:Hide()
	end
end

function Arena:RemoveDR(unit, category, status)
	if drs[unit][category] ~= status then return end
	drs[unit][category] = 0
	Arena:UpdateDisplays(unit)
end

function Arena:UpdateAuras(event,unit)
	if not unit:find("arena%d") then return end
	local shouldupdate = false
	if not auracache[unit] then print(unit) end
	for buff, ison in pairs(auracache[unit]) do
		if not UnitDebuff(unit, buff) then
			auracache[unit][buff] = nil
			shouldupdate = true
		end
	end
	local i = 1
	local name = UnitDebuff(unit, i)
	while name do
		if debuff_ids[name] then
			if not auracache[unit][name] then
				auracache[unit][name] = true
				drs[unit][dr_categories[debuff_ids[name]]] = (drs[unit][dr_categories[debuff_ids[name]]] or 0) + 1
				self:ScheduleTimer(15, "RemoveDR", unit, dr_categories[debuff_ids[name]], drs[unit][dr_categories[debuff_ids[name]]])
				if shared_drs[dr_categories[debuff_ids[name]]] then
					for k,cat in ipairs(shared_drs[dr_categories[debuff_ids[name]]]) do
						drs[unit][cat] = (drs[unit][cat] or 0)+1
						self:ScheduleTimer(15, "RemoveDR", unit, cat, drs[unit][cat])
					end
				end
				shouldupdate = true
			end
		end
		i=i+1
		name = UnitDebuff(unit, i)
	end
	if shouldupdate then
		Arena:UpdateDisplays(unit)
	end
	Arena:UpdateColoring(unit)
end

function Arena:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("ArenaConfig", defaults)
	options.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
	LibStub("LibDualSpec-1.0"):EnhanceDatabase(self.db, "Arena")
	LibStub("LibDualSpec-1.0"):EnhanceOptions(options.args.profiles, self.db)
	options.args.profiles.order = -1
	self.db.RegisterCallback(self, "OnProfileChanged", "OnProfileEnable")
	self.db.RegisterCallback(self, "OnProfileCopied", "OnProfileEnable")
	self.db.RegisterCallback(self, "OnProfileReset", "OnProfileEnable")
	self.opt = self.db.profile
	Arena:RegisterEvent("UPDATE_BATTLEFIELD_STATUS","UpdateFrameShowHide")
	Arena:RegisterEvent("PLAYER_REGEN_ENABLED")
	Arena:RegisterEvent("UNIT_AURA", "UpdateAuras")
	Arena:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "CombatEvent")
	self.frames = {}
	for i=1, 5 do
		local f = CreateFrame("Button", "ArenaEnemy"..i.."Button", UIParent, "SecureUnitButtonTemplate")
		SecureUnitButton_OnLoad(f,"arena"..i, function() end)
		for attribute,value in pairs(self.opt.attributes.enemy) do
			f:SetAttribute(attribute, value)
		end
		self.frames["arena"..i] = f
		if i > 1 then
			f:SetPoint("TOP", self.frames["arena"..(i-1)], "BOTTOM", 0, -10)
		else
			f:SetPoint(self.opt.positioning.enemy.point or "CENTER", nil, self.opt.positioning.enemy.rpoint or "CENTER", self.opt.positioning.enemy.x or 0, self.opt.positioning.enemy.y or 100)
		end
		f:SetScript("OnMouseUp", function(self)
			if not self.moving then return end
			self.moving = false
			self:StopMovingOrSizing()
			Arena.opt.positioning.enemy.point, _, Arena.opt.positioning.enemy.rpoint, Arena.opt.positioning.enemy.x, Arena.opt.positioning.enemy.y = self:GetPoint()
		end)
		f:SetHeight(100)
		f:SetWidth(300)
		f:SetScale(self.opt.positioning.enemy.scale or 1)
		f.unit = f:GetAttribute("unit")
		f.key = "arena"..i
		self:InitFrame(f)
		f.health.tx:SetVertexColor(1,0,0)
		f.texture:SetTexture("Interface\\AddOns\\Arena\\BG_enemy.tga")
		f.texture2:SetTexture("Interface\\AddOns\\Arena\\BG_enemy2.tga")
		f.power:SetPoint("BOTTOMLEFT", 90, 10)
		f.health:SetPoint("BOTTOM", f, "CENTER", 45, -20)
		f.health:SetPoint("TOPLEFT", 90, -30)
		for tx=5, 1, -1 do
			local btn = f:CreateTexture(nil, "OVERLAY")
			local btn_in = f:CreateTexture(nil, "ARTWORK")
			btn:SetWidth(14)
			btn:SetHeight(14)
			btn:SetTexture("Interface\\AddOns\\Arena\\button.tga")
			btn_in:SetAllPoints(btn)
			btn_in:SetTexture("Interface\\AddOns\\Arena\\button_in.tga")
			f["btn"..tx] = btn
			f["btn"..tx.."in"] = btn_in
			local spell = f:CreateTexture(nil, "OVERLAY")
			spell:SetWidth(18)
			spell:SetHeight(18)
			--spell:SetTexture("Interface\\Icons\\Spell_Magic_PolymorphPig")
			f["spell"..tx] = spell
			if tx == 5 then
				btn:SetPoint("TOPRIGHT", -7, -6)
			else
				btn:SetPoint("RIGHT", f["btn"..(tx+1)], "LEFT", -24, 0)
			end
			spell:SetPoint("RIGHT", btn, "LEFT", -3, 0)
			f.toptext:SetPoint("BOTTOMRIGHT", f, "TOPRIGHT")
		end
	end
	for i=1, 5 do
		local f = CreateFrame("Button", "ArenaMember"..i.."Button", UIParent, "SecureUnitButtonTemplate")
		SecureUnitButton_OnLoad(f, i > 1 and "party"..(i-1) or "player", function() end)
		for attribute, value in pairs(self.opt.attributes.friendly) do
			f:SetAttribute(attribute, value)
		end
		self.frames["team"..i] = f
		if i > 1 then
			f:SetPoint("TOP", self.frames["team"..(i-1)], "BOTTOM", 0, -10)
		else
			f:SetPoint(self.opt.positioning.friendly.point or "CENTER", nil, self.opt.positioning.friendly.rpoint or "CENTER", self.opt.positioning.friendly.x or 100, self.opt.positioning.friendly.y or -100)
		end
		f:SetScript("OnMouseUp", function(self)
			if not self.moving then return end
			self.moving = false
			self:StopMovingOrSizing()
			Arena.opt.positioning.friendly.point, _, Arena.opt.positioning.friendly.rpoint, Arena.opt.positioning.friendly.x, Arena.opt.positioning.friendly.y = self:GetPoint()
		end)
		f:SetHeight(100)
		f:SetWidth(300)
		f:SetScale(self.opt.positioning.friendly.scale or 1)
		f.unit = f:GetAttribute("unit")
		f.key = "team"..i
		self:InitFrame(f)
		f.health.tx:SetVertexColor(0,1,0)
		f.texture:SetTexture("Interface\\AddOns\\Arena\\BG_friendly.tga")
		f.texture2:SetTexture("Interface\\AddOns\\Arena\\BG_friendly2.tga")
		f.power:SetPoint("BOTTOMLEFT", 2, 10)
		f.health:SetPoint("BOTTOM", f, "CENTER", -45, -15)
		f.health:SetPoint("TOPLEFT", 2, -30)
		f.name = f:CreateFontString(nil, "OVERLAY")
		f.name:SetTextColor(1,1,1)
		f.name:SetFont(lsm3:Fetch("font", self.opt.looks.font), 14, "OUTLINE")
		f.name:SetPoint("TOPLEFT", 7, -4)
		f.name:SetHeight(20)
		f.name:SetWidth(200)
		f.toptext:SetPoint("BOTTOMLEFT", f, "TOPLEFT")
		if i== 1 then
			f.name:SetText((UnitName("player")))
		end
	end
end